/**
a exploding sphere by <a href="http://www.local-guru.net/blog">guru</a><br>
click on the sphere
*/
Particle[] particles;

int mode=0;
void setup() {
  size(300,300, P3D );
  initP();
}

void draw() {
  translate( width/2, height/2);
  background(0);
  lights();
  noStroke();
  pushMatrix();
  translate(0, 60, 0);
  fill(128);
  box( 500, 1, 300 );
  popMatrix();
  fill(255,0,0);
  if ( mode == 0 ) {
    sphere( 40 );
  } else {
    for( int i =0; i < particles.length; i++) {

      particles[i].update();
      particles[i].draw();
    }
  }

}

void mousePressed() {
  if ( mode == 0 ) {
    mode = 1;
  } else {
    initP();
    mode = 0;
  }
}

void initP() {
  particles = new Particle[400];
  for( int i =0; i < particles.length; i++) {
    PVector pos = new PVector( random(-40,40), random( -40,40), random( -40,40));
    pos.limit(40);
    PVector v = new PVector();
    v.set(pos);
    v.normalize();
    v.mult(3);
    particles[i] = new Particle( pos, v );
  }
}
class Particle {
  private PVector pos;
  private PVector v;
  
  public Particle( PVector pos ) {
    this.pos = pos;
    this.v = new PVector( 0,0,0 );
  }
  
  public Particle( PVector pos, PVector v ) {
    this.pos = pos;
    this.v = v;
  }
 
  void update() {
    if ( pos.y < 58 ) {
      pos.add(v);
      v.y += 1;
    } else {
      v.mult( 0.3 );
      v.y = -v.y;
      pos.add(v);
    }
  }
  
  void draw() {
    pushMatrix();
    translate( pos.x, pos.y, pos.z );
    box(2);
    popMatrix();
  }
}
